#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

void show_info(const char * text) {
  GtkWidget *dialog;
  dialog = gtk_message_dialog_new(GTK_WINDOW_TOPLEVEL,
            GTK_DIALOG_DESTROY_WITH_PARENT,
            GTK_MESSAGE_INFO,
            GTK_BUTTONS_OK,
            "%s", text);
  gtk_window_set_title(GTK_WINDOW(dialog), "Information");
  gtk_dialog_run(GTK_DIALOG(dialog));
  gtk_widget_destroy(dialog);
}

void show_error(const char * text) {
  GtkWidget *dialog;
  dialog = gtk_message_dialog_new(GTK_WINDOW_TOPLEVEL,
            GTK_DIALOG_DESTROY_WITH_PARENT,
            GTK_MESSAGE_ERROR,
            GTK_BUTTONS_OK,
            "%s", text);
  gtk_window_set_title(GTK_WINDOW(dialog), "Error");
  gtk_dialog_run(GTK_DIALOG(dialog));
  gtk_widget_destroy(dialog);
}

void show_question(const char * text) {
  GtkWidget *dialog;
  dialog = gtk_message_dialog_new(GTK_WINDOW_TOPLEVEL,
            GTK_DIALOG_DESTROY_WITH_PARENT,
            GTK_MESSAGE_QUESTION,
            GTK_BUTTONS_YES_NO,
            "%s", text);
  gtk_window_set_title(GTK_WINDOW(dialog), "Question");
  gtk_dialog_run(GTK_DIALOG(dialog));
  gtk_widget_destroy(dialog);
}

void show_warning(const char * text) {
  GtkWidget *dialog;
  dialog = gtk_message_dialog_new(GTK_WINDOW_TOPLEVEL,
            GTK_DIALOG_DESTROY_WITH_PARENT,
            GTK_MESSAGE_WARNING,
            GTK_BUTTONS_OK,
            "%s", text);
  gtk_window_set_title(GTK_WINDOW(dialog), "Warning");
  gtk_dialog_run(GTK_DIALOG(dialog));
  gtk_widget_destroy(dialog);
}

int main( int argc, char *argv[]) {
  if (execv(argv[1], argv+1) < 0) {
    char str[128];
    switch (errno) {
      case EACCES:
        snprintf(str, sizeof(str),"The program couldn't be started.\nAre you sure you have the right permissions?\nHint: Add yourself to group packeth");
        break;
      case ENOENT:
        snprintf(str, sizeof(str),"The program doesn't exist.\nAre you sure that it's path is correct?");
        break;
      default:
        snprintf(str, sizeof(str),"The program couldn't be started.\nError %d: %s", errno, strerror(errno));
    }
    str[sizeof(str)-1] = '\0';
    gtk_init(&argc, &argv);
    show_warning(str);
    return EXIT_FAILURE;
  }
  return EXIT_SUCCESS;
}
